
on *:SIGNAL:httpd/*: {
  var %sock = $signal
  if ($0) {
    echo -s $sock(%sock).ip - - $asctime($ctime,[dd/mmm/yyyy:HH:nn:ss zz]) $qt($iif($hget(%sock,method,&method),$bvar(&method,1,64).text) $iif($hget(%sock,request,&request),$bvar(&request,1,256).text) $iif($hget(%sock,version,&version),$bvar(&version,1,64).text)) $2 $iif($hget(%sock,Content-Length:),$v1,0)
    bset -t &head 1 $1- $+ $crlf
    hadd -m %sock Date: $asctime($ctime,ddd $+ $chr(44) dd mmm yyyy HH:nn:ss) GMT
    hadd -m %sock Server: $+(mIRC,/,$version)
    hadd -m %sock Connection: close
    while ($hfind(%sock,*:,1,w)) {
      bset -t &head $calc($bvar(&head,0) + 1) $v1 $hget(%sock,$v1) $+ $crlf
      hdel %sock $v1
    }
    bset -t &head $calc($bvar(&head,0) + 1) $crlf
    sockwrite -b %sock $bvar(&head,0) &head
  }
}
on *:START: {
  if ($hget(httpd)) hfree $v1 | hmake httpd | hinc httpd sock 0
  if ($hget(httpd/mime.types)) hfree $v1 | hmake httpd/mime.types | hload httpd/mime.types htdocs/mime.types
  if ($sock(httpd)) sockclose $v1 | socklisten -d 0.0.0.0 httpd 80
}
on *:SOCKLISTEN:httpd: {
  hinc httpd sock
  sockaccept $+($sockname,/,$hget(httpd,sock))
  if ($sockerr) {
    sockclose $+($sockname,/,$hget(httpd,sock))
  }
}
on *:SOCKREAD:httpd/*: {
  :rq
  if ($sockerr) {
    hfree $sockname
    sockclose $sockname
  }
  elseif ($sock($sockname).rq > 0) {
    sockread 8192 $+(&,$sockname)
    bcopy -c &read $calc($hget($sockname,read,&read) + 1) $+(&,$sockname) 1 -1
    hadd -mb $sockname read &read
    if ($bfind(&read,0,13 10 13 10)) {
      var %offset = $v1 + 4, %length = $bvar(&read,0) - %offset
      if ($bfind(&read,0,13 10)) {
        bcopy -c &request 1 &read 1 $calc($v1 - 1)
        if ($bfind(&request,0,32)) {
          bcopy -c &method 1 &request 1 $calc($v1 - 1)
          bcopy -c &request 1 &request $calc($v1 + 1) -1
          hadd -mb $sockname method &method
        }
        if ($bfind(&request,0,32)) {
          bcopy -c &version 1 &request $calc($v1 + 1) -1
          bcopy -c &request 1 &request 1 $calc($v1 - 1)
          hadd -mb $sockname version &version
        }
        if ($bfind(&request,0,63)) {
          bcopy -c &query 1 &request $calc($v1 + 1) -1
          bcopy -c &request 1 &request 1 $calc($v1 - 1)
          hadd -mb $sockname query &query
        }
        bcopy -c &request 1 &request 1 256
        hadd -mb $sockname request &request
      }
      if ($hget($sockname,method,&method)) {
        if ($bfind(&method,0,GET)) { }
        elseif ($bfind(&method,0,HEAD)) { }
        elseif ($bfind(&method,0,POST)) {
          var %offset = $bfind(&read,0,13 10) + 2
          if ($bfind(&read,%offset,Content-Length:)) { }
          else {
            var %status = HTTP/1.1 411 Length Required
            goto error
          }
          while ($sock($sockname).rq) {
            sockread 8192 $+(&,$sockname)
            bcopy -c &read $calc($bvar(&read,0) + 1) $+(&,$sockname) 1 -1
            hadd -mb $sockname read &read
            if ($hget($sockname,read,&read) > 2097152) {
              var %status = HTTP/1.1 413 Request Entity Too Large
              goto error
            }
          }
        }
        else {
          var %status = HTTP/1.1 501 Not Implemented
          goto error
        }
      }
      if ($hget($sockname,request,&request)) {
        var %i = 1, %l = $v1, %request
        while (%i <= %l) {
          var %char = $bvar(&request,%i,1), %i = %i + 1
          if (%char == 37) {
            var %char = $base($bvar(&request,%i,2).text,16,10), %i = %i + 2
            if (%char == 32) var %char, %request = $+(%request,$(%20,))
          }
          elseif (%char == 43) var %char, %request = $+(%request,$(%20,))
          if (%char == 47) || (%char == 92) {
            var %file = $nopath(%request), %request = $+(%request,/)
            if (%file == .) var %request = $nofile($mid(%request,1,-1))
            if (%file == ..) var %request = $nofile($mid(%request,1,-4))
          }
          elseif (%char) var %request = $+(%request,$chr($v1))
        }
      }
      if (%request) {
        var %request = $utfdecode($replace($v1,$(%20,),$chr(32))), %path = $+($mircdir,htdocs,%request)
        if ($len(%path) < 256) {
          if ($isdir(%path)) {
            if (*/ iswm %request) {
              if ($isfile($+(%path,index.html))) var %path = $+(%path,index.html)
              elseif ($isfile($+(%path,index.htm))) var %path = $+(%path,index.htm)
              else {
                var %i = 0, %window = $+(@,$sockname)
                window -h %window 0 0 0 0
                if ($finddir(%path,*,0,0,aline %window directory - - $nopath($1-))) var %i = %i + $v1
                if ($findfile(%path,*,0,0,aline %window file $lof($1-) $file($1-).mtime $nopath($1-))) var %i = %i + $v1
                filter -wwceut 1 32 %window %window
                bset -t &write $calc($bvar(&write,0) + 1) <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
                bset -t &write $calc($bvar(&write,0) + 1) <html xmlns="http://www.w3.org/1999/xhtml">
                bset -t &write $calc($bvar(&write,0) + 1) <head>
                bset -t &write $calc($bvar(&write,0) + 1) <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
                bset -t &write $calc($bvar(&write,0) + 1) <meta name="author" content="Ivan Alex. G. aka Spoofing" />
                bset -t &write $calc($bvar(&write,0) + 1) <meta name="robots" content="index,all" />
                bset -t &write $calc($bvar(&write,0) + 1) <title> $+ Index of %request $+ </title>
                bset -t &write $calc($bvar(&write,0) + 1) </head>
                bset -t &write $calc($bvar(&write,0) + 1) <body>
                bset -t &write $calc($bvar(&write,0) + 1) <h1> $+ Index of %request $+ </h1>
                bset -t &write $calc($bvar(&write,0) + 1) <table>
                bset -t &write $calc($bvar(&write,0) + 1) <tr>
                bset -t &write $calc($bvar(&write,0) + 1) <th><img src="/icons/blank.gif" alt="[ICO]" width="20" height="22"></th>
                bset -t &write $calc($bvar(&write,0) + 1) <th>Name</th>
                bset -t &write $calc($bvar(&write,0) + 1) <th>Last modified</th>
                bset -t &write $calc($bvar(&write,0) + 1) <th>Size</th>
                bset -t &write $calc($bvar(&write,0) + 1) </tr>
                bset -t &write $calc($bvar(&write,0) + 1) <tr>
                bset -t &write $calc($bvar(&write,0) + 1) <th colspan="4"><hr></th>
                bset -t &write $calc($bvar(&write,0) + 1) </tr>
                if (/*/* iswm %request) {
                  bset -t &write $calc($bvar(&write,0) + 1) <tr>
                  bset -t &write $calc($bvar(&write,0) + 1) <td valign="top"><img src="/icons/back.gif" alt="[DIR]" width="20" height="22"></td>
                  bset -t &write $calc($bvar(&write,0) + 1) <td><a href="/">Parent Directory</a></td>
                  bset -t &write $calc($bvar(&write,0) + 1) <td align="right">&nbsp;</td>
                  bset -t &write $calc($bvar(&write,0) + 1) <td align="right">-</td>
                  bset -t &write $calc($bvar(&write,0) + 1) </tr>
                }
                while (%i) {
                  var %object = $line(%window,%i), %type = $gettok(%object,1,32), %name = $gettok(%object,4-,32), %i = %i - 1
                  if (%type == directory) {
                    bset -t &write $calc($bvar(&write,0) + 1) <tr>
                    bset -t &write $calc($bvar(&write,0) + 1) <td valign="top"><img src="/icons/folder.gif" alt="[DIR]" width="20" height="22"></td>
                    bset -t &write $calc($bvar(&write,0) + 1) <td><a href=" $+ $replace(%name,$(#,),$(%23,)) $+ /"> $+ %name $+ </a>/</td>
                    bset -t &write $calc($bvar(&write,0) + 1) <td align="right">&nbsp;</td>
                    bset -t &write $calc($bvar(&write,0) + 1) <td align="right">-</td>
                    bset -t &write $calc($bvar(&write,0) + 1) </tr>
                  }
                  elseif (%type == file) {
                    var %lof = $gettok(%object,2,32), %mtime = $gettok(%object,3,32)
                    bset -t &write $calc($bvar(&write,0) + 1) <tr>
                    bset -t &write $calc($bvar(&write,0) + 1) <td valign="top"><img src="/icons/unknown.gif" alt="[   ]" width="20" height="22"></td>
                    bset -t &write $calc($bvar(&write,0) + 1) <td><a href=" $+ $replace(%name,$(#,),$(%23,)) $+ "> $+ %name $+ </a></td>
                    bset -t &write $calc($bvar(&write,0) + 1) <td align="right"> $+ $asctime(%mtime,dd-mm-yyyy HH:nn) $+ </td>
                    bset -t &write $calc($bvar(&write,0) + 1) <td align="right"> $+ $bytes(%lof).suf $+ </td>
                    bset -t &write $calc($bvar(&write,0) + 1) </tr>
                  }
                }
                bset -t &write $calc($bvar(&write,0) + 1) <tr>
                bset -t &write $calc($bvar(&write,0) + 1) <th colspan="4"><hr></th>
                bset -t &write $calc($bvar(&write,0) + 1) </tr>
                bset -t &write $calc($bvar(&write,0) + 1) </table>
                bset -t &write $calc($bvar(&write,0) + 1) <address> $+ $+(mIRC,/,$version) run as /socklisten -d $sock(httpd).ip httpd $sock(httpd).port $+ </address>
                bset -t &write $calc($bvar(&write,0) + 1) </body>
                bset -t &write $calc($bvar(&write,0) + 1) </html>
                window -c %window
              }
            }
            else {
              var %status = HTTP/1.1 302 Found
              hadd -m $sockname Location: $+(%request,/)
              goto error
            }
          }
        }
        else {
          var %status = HTTP/1.1 414 Request-URL Too Long
          goto error
        }
      }
      if ($isdir(%path)) {
        var %status = HTTP/1.1 200 OK
        hadd -m $sockname Content-Type: text/html; charset=UTF-8
        hadd -m $sockname Content-Length: $bvar(&write,0)
        hadd -m $sockname ETag: $qt($md5(&write,1))
        hadd -m $sockname Cache-Control: no-cache, no-store, max-age=0, must-revalidate
        hadd -m $sockname Pragma: no-cache
        hadd -mb $sockname write &write
      }
      elseif ($isfile(%path)) {
        var %status = HTTP/1.1 200 OK, %file = $nopath(%path)
        hadd -m $sockname Content-Type: application/octet-stream
        hadd -m $sockname Content-Length: $lof(%path)
        hadd -m $sockname ETag: $qt($md5(%path,2))
        hadd -m $sockname Last-Modified: $asctime($file(%path).mtime,ddd $+ $chr(44) dd mmm yyyy HH:nn:ss) GMT
        hadd -m $sockname offset 0
        hadd -m $sockname lof $lof(%path)
        hadd -m $sockname path $qt(%path)
        if ($hget(httpd/mime.types,$mid(%file,$calc($pos(%file,.) + 1)))) {
          hadd -m $sockname Content-Type: $v1
        }
      }
      else {
        var %status = HTTP/1.1 404 Not Found
        goto error
      }
      :error
      if ($error) {
        var %status = HTTP/1.1 500 Internal Server Error
        reseterror
      }
      if ($hget($sockname,Content-Type:) == application/x-httpd-mirc) {
        hadd -m $sockname X-Powered-By: mIRC
        hadd -m $sockname X-Version: $version
        if ($script($hget($sockname,path))) {
          hadd -m $sockname offset $hget($sockname,lof)
          scid -r $mid($read($v1,n,1),2)
        }
        else {
          signal $sockname %status
        }
      }
      else {
        signal $sockname %status
      }
    }
    elseif ($bvar(&read,0) > 16384) {
      hfree $sockname
      sockclose $sockname
    }
    goto rq
  }
}
on *:SOCKWRITE:httpd/*: {
  if ($sockerr) {
    hfree $sockname
    sockclose $sockname
  }
  elseif ($sock($sockname).sq == 0) {
    if ($hget($sockname,write,&write)) {
      bcopy -c &packet 1 &write 1 16384
      sockwrite -b $sockname $bvar(&packet,0) &packet
      if ($bvar(&packet,0) < $bvar(&write,0)) {
        bcopy -c &write 1 &write $calc($v1 + 1) -1
        hadd -b $sockname write &write
      }
      else {
        hdel $sockname write
      }
    }
    elseif ($hget($sockname,offset) < $hget($sockname,lof)) {
      bread $hget($sockname,path) $v1 16384 &packet
      sockwrite -b $sockname $bvar(&packet,0) &packet
      hinc $sockname offset $bvar(&packet,0)
    }
    else {
      if ($hget($sockname)) {
        hfree $sockname
      }
      sockclose $sockname
    }
  }
}
on *:SOCKCLOSE:httpd/*: {
  if ($hget($sockname)) {
    hfree $sockname
  }
  sockclose $sockname
}
